function [nuB]=biasnu(nu,br,Vr,tau,T,K,nbtraded)
n=size(br,1);
%=========================================================================%
% This function computes the unbiased estimator of nu for the unconditional
% model - Proposition 4
% Author of code: Elisa Ossola
%=========================================================================%
K1=K-nbtraded;
c=[1;-nu];              %(K+1)x1, nu is the WLS estimator
Bs1=zeros(K1,1);         %sum in the bias_nu
v=zeros(n,1);           %vector of vii
w=zeros(n,1);           %vector of weigths w
wstest=zeros(n,1);     %vector of weigths w pour le test de GOS
E2=[zeros(1,K1); eye(K1)];%selection matrix E2
D=duplication(K1+1);     %duplication matrix
cui=[];
for i=1:n
    vecVxi=D*Vr(i,:)';
    Wxi=invVec(vecVxi,K1+1,K1+1); %Wxi=inv(Qxi)*Sii*inv(Qxi)- matrix(K+1)x(K+1)
    Bs1=Bs1+tau(i,1)*E2'*Wxi*c; %sum in the bias term of nu - Prop.2    
end;
Qb=(br'*br)/n;        %weighted second moment of estimated b
Bnu=Qb\(Bs1/n); %Bias term
nuB=nu-Bnu/T;          %unbiased estimator of nu 