function [a,b,br,Vr,CN,Ti]=firstpass(ExcR,I,F,Fo,nbtraded)
%time-series regression of the portfolio excess returns on the factors

K1=size(F,2);
K2=K1+size(Fo,2);
n=size(ExcR,2);
T=size(ExcR,1);
check=(I==1);
Ti=sum(check,1)';
X=[ones(T,1),F,Fo];
a=zeros(n,1);
b=zeros(n,K1);
K1b=K1-nbtraded;
CN=zeros(n,1);
br=zeros(n,K1b);
Vr=zeros(n,(K1b+1)*(K1b+1+1)/2);
res=zeros(T,n);
for i=1:n;  
    if Ti(i)>0,
        Ii=repmat(I(:,i),1,K2+1);
        ExcR(:,i)=I(:,i).*ExcR(:,i);
        Xi=Ii.*X;                         
        Qxi=(Xi'*Xi)/Ti(i);      
    
        %Beta - OLS estimators
        beta=(inv(Qxi))*(Xi'*ExcR(:,i)/Ti(i));
        a(i,:)=beta(1,1);
        b(i,:)=beta(2:K1+1,1);
        
        %Condition number - Greene (2008)
        Xtildei=zeros(T,(K2+1));     
        for s=1:(K2+1);
            Xtildei(:,s)=Xi(:,s)/norm(Xi(:,s)); 
        end;
        Qxtildei=(Xtildei'*Xtildei)/Ti(i);
        l=eig(Qxtildei);
        if l>0;                     
            CN(i,1)=sqrt(max(l)/min(l));
        else                         
            CN(i,1)=100;
        end;
 
        res(:,i)=ExcR(:,i)-Xi*beta;
        indic=find(I(:,i)==1);
        %White estimator
        [S]=white(Xi(indic,:),res(indic,i));
        
        %selection of the appropriate rows to only take the nontraded
        %factors for the second-pass regression
       indicr=[nbtraded+1:1:K1]'; 
       indicr1=[1,1+nbtraded+1:1:K1+1]';
        br(i,:)=b(i,indicr);
        Vr(i,:)=(vech(S(indicr1,indicr1)))';
    end
end