function[propvec]=propcomp(tstatpe,interval)
%computation of the mispricing proportion
M=size(tstatpe,1);
W=sum(tstatpe>-interval & tstatpe<interval)/M;
q=normcdf(interval,0,1)-normcdf(-interval,0,1);
propnull=W/q;
if propnull<0,
   propnull=0;
elseif propnull>1,
    propnull=1;
end
propmis=1-propnull;

%computation of the proportions of portfolios with negative and positive
%pricing errors
Wneg=sum(tstatpe<-interval);
propneg=Wneg/M-propnull*normcdf(-interval,0,1);
Wpos=sum(tstatpe>interval);
proppos=Wpos/M-propnull*(1-normcdf(interval,0,1));

if propneg<0 | propmis==0,
   propneg=0;
elseif propneg>1,
    propneg=1;
end
if proppos<0 | propmis==0,
   proppos=0;
elseif proppos>1,
    proppos=1;
end
if propmis>0,
   ratio=(propneg+proppos)/propmis; 
   propneg=(1/ratio)*propneg;
   proppos=(1/ratio)*proppos;
end
propvec=[propmis;propneg;proppos];
