function[Rmpy,ERmpy,ERysold,idstockyold,idmpold]=timeaveraging(Ry,ERy,ERys,idstocky,ERysold,idstockyold,idmpold)
%program used by microport to chain the returns of the micro portfolios 
%across time

Nmp=size(idmpold,2);
Ty=size(Ry,1);
Ny=size(Ry,2);
Rmpy=-999*ones(Ty,Nmp);
ERmpy=-999*ones(Ty,Nmp);
indicmpold=[1:1:Nmp];
indicstock=[1:1:Ny];
i1=kron(indicmpold',ones(Ny,1));
i2=kron(ones(Nmp,1),indicstock');
i3=kron(idstockyold',ones(Ny,1));
i4=kron(ones(Nmp,1),idstocky');
k1=kron(ERysold',ones(Ny,1));
k2=kron(ones(Nmp,1),ERys');
distance=abs(k1-k2);
mat=[i1,i2,i3,i4,k1,k2,distance];
mats=sortrows(mat,7);

% Step 1: we match the portfolios constructed on the same stock when
%the average return remain sufficiently close (i.e., if the distance if in
%the top 1%)
ss=size(mats,1);
thres=mats(round(0.01*ss),7);
matchbase=[];
for q=1:Nmp,
    indicsame=find(mats(:,1)==indicmpold(1,q) & mats(:,4)==idstockyold(1,q));
    if size(indicsame,1)>0 & mats(indicsame,7)<thres,
       matchbase=[matchbase;mats(indicsame,:)];
       %then, we eliminate the pair
       indic=find(mats(:,1)~=mats(indicsame,1) & mats(:,2)~=mats(indicsame,2));
       mats=mats(indic,:);
    end
end

%Step 2: we match the remaining portfolios with the closest average returns
Nmp2=Nmp-size(matchbase,1);
Ny2=Ny-size(matchbase,1);
if Nmp2<Ny2,
    matchbase2=zeros(Nmp2,7);
    for q=1:Nmp2,
        matchbase2(q,:)=mats(1,:);
        %then, we eliminate the pair
        indic=find(mats(:,1)~=mats(1,1) & mats(:,2)~=mats(1,2));
        mats=mats(indic,:);
    end
else
    matchbase2=zeros(Ny2,7);
    for q=1:Ny2,
        matchbase2(q,:)=mats(1,:);
        %then, we eliminate the pair
        indic=find(mats(:,1)~=mats(1,1) & mats(:,2)~=mats(1,2));
        mats=mats(indic,:);
    end
end
matchtot=[matchbase;matchbase2];

%Step 3: we perform the chaining of the portfolio returns and update 
%the vector of characteristics and identifiers for the next iteration
oldsort=matchtot(:,1);
newsort=matchtot(:,2);
ERysold(1,oldsort)=matchtot(:,6)';

%we sort the column of the returns and average returns to chain the returns correctly
%the unmatched portfolios have entries -999
Rmpy(:,oldsort)=Ry(:,newsort);
ERmpy(:,oldsort)=ERy(:,newsort);

%Step 4: if the cross-section expands, we need to add the new portfolios
if Nmp<Ny;
   iadd=setdiff(indicstock',newsort);
   Radd=Ry(:,iadd);
   ERadd=ERy(:,iadd);
   ERadds=ERys(1,iadd);
   idstockadd=idstocky(1,iadd);
   Rmpy=[Rmpy,Radd];
   ERmpy=[ERmpy,ERadd];
   ERysold=[ERysold,ERadds];
   idmpold=[1:1:(Nmp+size(iadd,1))];
   idstockyold=[idstockyold,idstockadd];
end