function[tstatpe,pe]=tstatpecomp(a,br,nuB,Vr,Ti);
%program used by perfeval to compute the tstatistics of the portfolio 
%pricing errors as discussed in Section II.C

n=size(a,1);
K=size(br,2);
pe=zeros(n,1);
tstatpe=zeros(n,1);
D=duplication(K+1);
for i=1:n,
    pe(i,1)=a(i,1)-br(i,:)*nuB;
    vecV=D*Vr(i,:)';       
    S=invVec(vecV,K+1,K+1);
    stdalpha=(1/sqrt(Ti(i)))*(S(1,1)+nuB'*S(2:end,2:end)*nuB-2*S(1,2:end)*nuB)^(1/2);
    tstatpe(i,1)=pe(i,1)./stdalpha;
end
