function [a,br,Vr,nuB,Ti,ERvec,lambdaB,b]=twopass(ExcR,F,Fo,I,Ti,ERvec,mindata,nbtraded)                                                                               
%program used by perfeval to compute regression coefficients, forward prices, 
%and risk premia using the extended two-pass regression presented in 
%Section II.C

%first pass
[a,b,br,Vr,CN,Ti]=firstpass(ExcR,I,F,Fo,nbtraded);

%Trimming thresholds
chi1=15;
T=size(ExcR,1);
chi2=T/mindata;
tau=T./Ti;  

%first trimming
ind=find(CN<=chi1);
a=a(ind,:); 
b=b(ind,:); 
br=br(ind,:); 
Vr=Vr(ind,:); 
tau=tau(ind,:);
Ti=Ti(ind,:);
ERvec=ERvec(ind,:);
%second trimming
ind=find(tau<=chi2);  
a=a(ind,:); 
b=b(ind,:); 
br=br(ind,:); 
Vr=Vr(ind,:); 
tau=tau(ind,:);
Ti=Ti(ind,:);
ERvec=ERvec(ind,:);

%second pass
K1=size(F,2);
if nbtraded<K1;
   nu=regress(a,br);
   %adjustment for the bias in the forward prices
   [nuB]=biasnu(nu,br,Vr,tau,T,K1,nbtraded);
   e0=zeros(1:nbtraded,1);
   lambdaB=[e0;nuB]+mean(F)';
else
   nuB=[];
   lambdaB=mean(F)';
end
