function[stdprop,varprop]=volpropmis(tstatpeo,interval,lag)
%estimated volatility for the mispricing proportion
M=size(tstatpeo,1);
sslag=zeros(lag,1);
for i=1:lag,
    s=sum(abs(tstatpeo(i+1:end,1))<interval & abs(tstatpeo(1:end-i,1))<interval,1);
    ss=(1/(M-i))*s;
    sslag(i,1)=ss;
end
s0=sum(abs(tstatpeo)<interval,1);
ss0=(1/M)*s0;
ssa0=ss0-ss0^2;
ssalag=2*sum((sslag-ones(lag,1)*ss0^2));
ssat=(ssa0+ssalag);
q=normcdf(interval,0,1)-normcdf(-interval,0,1);
varprop=(1/M)*(ssat/q^2);
stdprop=sqrt(varprop);

