function[stdpropneg]=volpropneg(tstatpeo,interval,lag,varprop)
%estimated volatility for the proportion of portfolios with negative
%mispricing
M=size(tstatpeo,1);
sslag=zeros(lag,1);
for i=1:lag,
    s=sum(tstatpeo(i+1:end,1)<-interval & tstatpeo(1:end-i,1)<-interval,1);
    ss=(1/(M-i))*s;
    sslag(i,1)=ss;
end
s0=sum(tstatpeo<-interval,1);
ss0=(1/M)*s0;
ssa0=ss0-ss0^2;
ssalag=2*sum(sslag-ones(lag,1)*ss0^2);
ssat=(ssa0+ssalag);
varianceneg=ssat/M;

sslag=zeros(lag,1);
sslag1=zeros(lag,1);
for i=1:lag,
    s=sum(abs(tstatpeo(i+1:end,1))<interval & tstatpeo(1:end-i,1)<-interval,1);
    ss=(1/(M-i))*s;
    sslag(i,1)=ss;
    s1=sum(tstatpeo(i+1:end,1)<-interval & abs(tstatpeo(1:end-i,1))<interval,1);
    ss1=(1/(M-i))*s1;
    sslag1(i,1)=ss1;
end
%we continue with the contemporaneous covariance matrix
sm=sum(tstatpeo<-interval,1);
ssm=(1/M)*sm;
s0=sum(abs(tstatpeo)<interval,1);
ss0=(1/M)*s0;
ssa=-ss0*ssm;
ssalag=sum(sslag-ones(lag,1)*ss0*ssm);
ssalag1=sum(sslag1-ones(lag,1)*ss0*ssm);
ssat=(ssa+ssalag+ssalag1);
q=normcdf(interval,0,1)-normcdf(-interval,0,1);
qneg=normcdf(-interval,0,1);
covterm=(ssat*qneg/q)/M;

%calcul de l ecart-type
variance0=varprop*qneg^2;
varpropneg=(varianceneg+variance0-2*covterm);
stdpropneg=sqrt(varpropneg);